

/**
 *
 * @author Jon Frain
 */


import java.io.*;
import java.util.*;



public class ClassicImplementation {

//    //-------------------------------------------------------------------
//    // void runMapCode
//    //
//    //--------------------------------------------------------------------
//    public static void runMapCode(double[] ssError, double[][][] initArr3,
//                           double[][][] transformedArr,
//                           double[][][] compressedArr,
//                           int dim1, int dim2, int dim3,
//                           int lvl )
//    {
//        // This Map comparitor code commandeered from Alex Hill's response on:
//        //    - www.theserverside.com/discussions/thread.tss?thread_id=29569
//        //
//        // Frain - Maps easily sorted by key but not by value.
//        Map<Integer, Float> map = new HashMap<Integer, Float>();
//
//        // --- Put entries into map here ---
//        for (int i = 0; i < 8; i++) {
//            map.put(i, ssError[i]);
//        }
//
//        // Get a list of the entries in the map
//        List<Map.Entry<Integer, Float>> list =
//                         new Vector<Map.Entry<Integer, Float>>(map.entrySet());
//
//        // Sort the list using an anonymous inner class implementing
//        // Comparator for the compare method
//        java.util.Collections.sort(list,
//                new Comparator<Map.Entry<Integer, Float>>() {
//                    public int compare(Map.Entry<Integer, Float> entry1,
//                            Map.Entry<Integer, Float> entry2) {
//                        // Return 0 for a match, -1 for less than and +1
//                        // for more then
//                        if (entry1.getValue().equals(entry2.getValue())) {
//                            return 0;
//                        } else if (entry1.getValue() > entry2.getValue()) {
//                            return -1;
//                        } else {
//                            return 1;
//                        }
//                    }
//                });
//
//        int ordered_regions[] = new int[8];
//        Iterator<Map.Entry<Integer, Float>> it = list.iterator();
//        for (int i = 0; it.hasNext(); i++) {
//            Map.Entry<Integer, Float> myEntry = it.next();
//            ordered_regions[i] = myEntry.getKey().intValue();
//            System.out.println("ordered_regions[i] = " + ordered_regions[i] +
//                    " i = " + i);
//            System.out.println(" myEntry.getValue().intValue()= "
//                               + myEntry.getValue().intValue());
//        } // for (int i=0; it.hasNext(); i++)
//
//        for (int i = 0; i < 8; i++) {
//            ArrayUtil.copyArray(compressedArr, transformedArr);
//
//            // set all but i best regions to zero
//            for (int j = i; j < 7; j++) {
//                System.out.println(" zeroing out region: "
//                                + Region.region.getRegion(ordered_regions[j]));
//                Region.setDetailRegionZeros(compressedArr,
//                        Region.region.getRegion(ordered_regions[j]), lvl);
//            }
//            // inverse transform array
//            HaarTransform.inverseTransform(compressedArr, compressedArr,
//                    dim1, dim2, dim3);
//            System.out.println("\n\n SUM SQUARED ERROR FOR SSS DATA AND "
//                               + i + " BEST");
//            System.out.println("=============================");
//            ErrorUtility.calcAndPrintError(initArr3, compressedArr, "SSS+" + i,
//                    fileName, range, log);
//        } // for (int i=0; i<8;i++)
//
//
//        // Frain - commenting out classic code for now
////        // Use classic approach to determine N largest detail coefficients
////        // and apply "classic" approach
////        for (int i = 1; i < 8; i++) {
////            ArrayUtil.copyArray(compressedArr, transformedArr);
////
////            setLargestCoeffs(compressedArr, transformedArr, i, 64, lvl);
////
////            HaarTransform.inverseTransform(compressedArr,
////                                               compressedArr,
////                                               dim1, dim2, dim3);
////            System.out.println("\n\n SUM SQUARED ERROR FOR Classic Method "
////                               + "(64 bit pairs)");
////            System.out.println("=========================================="
////                               + "============");
////            calcAndPrintError(initArr3, compressedArr, "C64-" + i);
////        }
//    }



//    //-------------------------------------------------------------------------
//    // setLargestCoeffs(double testArray[][][], double origArray[][][],
//    //                  int numRegions)
//    //
//    // depth - how many levels of transformations occurred
//    //
//    // sets up array using "classic" approach
//    //-------------------------------------------------------------------------
//    public static void setLargestCoeffs( double array[][][],
//                                  double transformedArray[][][],
//                                  int numRegions, int pairSize, int lvl)
//    {
//        int lenDim1 = array.length;
//        int lenDim2 = array[0].length;
//        int lenDim3 = array[0][0].length;
//
//        int numElementsPerRegion = (lenDim1 / 2) * (lenDim2 / 2) * (lenDim3 / 2);
//        int numElements = numRegions * numElementsPerRegion;
//
//        // for Jimmy data and head data - each (loc,value) pair is
//        // 23bits+32bits = 55 bits each element in original data is 4 bytes
//        int numCoefficients = numElements * 4 / (pairSize / 8);
//
//        System.out.println("++++ numCoefficients = " + numCoefficients + "++++");
//
//        // Call helper method
//        setNLargestCoeffs(array, transformedArray, numCoefficients, lvl);
//
//        region_percentages[0] = 100;
//        for (int i = 1; i < 8; i++) {
//           region_percentages[i] =
//             (classic_region_coefficient_count[i] / numElementsPerRegion) * 100;
//        }
//    }
//
//    //-------------------------------------------------------------------------
//    // setNLargestCoeffs(double array[][][], int numValues)
//    //
//    // sets up array using "classic" approach
//    //-------------------------------------------------------------------------
//    private static void setNLargestCoeffs(double array[][][],
//            double transformedArray[][][],
//            int numValues, int lvl)
//    {
//        int lenDim1 = array.length;
//        int lenDim2 = array[0].length;
//        int lenDim3 = array[0][0].length;
//
//        LocValPair[] nLargest = new LocValPair[numValues];
//
//        int arrSize = 7 * lenDim1 * lenDim2 * lenDim3 / 8;
//        LocValPair[] all = new LocValPair[arrSize];
//
//        // look at every coefficient and sort them into array 'all'
//        fillAndSortLocValPairArray(all, array);
//
//        // Grab the N largest values
//        System.arraycopy(all, 0, nLargest, 0, numValues);
//
//        // reset array to original values
//        ArrayUtil.copyArray(array, transformedArray);
//
//        // set all but SSS region to zero
//        for (int j = 1; j <= 7; j++) {
//            System.out.println(" zeroing out region: " + Region.region.getRegion(j));
//            Region.setDetailRegionZeros(array, Region.region.getRegion(j), lvl);
//        }
//
//        // place the N largest coefficients in array
//        System.out.println("++++++ Setting " + numValues + " of coefficients");
//        int xLoc = 0, yLoc = 0, zLoc = 0;
//        classic_region_coefficient_count = new double[8];
//        classic_region_coefficient_sum = new double[8];
//
//        for (int i = 0; i < 8; i++) {
//            classic_region_coefficient_count[i] = 0;
//            classic_region_coefficient_sum[i] = 0;
//        }
//        int region = 0;
//        for (int i = 0; i < numValues; i++) {
//            xLoc = nLargest[i].getX();
//            yLoc = nLargest[i].getY();
//            zLoc = nLargest[i].getZ();
//
//            region = Region.getRegionFromLoc(xLoc, yLoc, zLoc,
//                    lenDim1, lenDim2, lenDim3);
//
//            classic_region_coefficient_count[region]++;
//            classic_region_coefficient_sum[region] +=
//                    Math.abs(transformedArray[xLoc][yLoc][zLoc]);
//            // assign value
//            array[xLoc][yLoc][zLoc] = transformedArray[xLoc][yLoc][zLoc];
//        }
//    }
//
//    //-------------------------------------------------------------------------
//    // fillAndSortLocValPairArray
//    //
//    // sets up array using "classic" approach
//    //-------------------------------------------------------------------------
//    private static void fillAndSortLocValPairArray(LocValPair[] array, double doubleArray[][][])
//    {
//        int lenDim1 = doubleArray.length;
//        int lenDim2 = doubleArray[0].length;
//        int lenDim3 = doubleArray[0][0].length;
//
//        // ensure the algorithm won't try to later change an SSS value
//        Region.setDetailRegionVal(doubleArray, Region.region.SSS, 0, 0);
//
//        // Fill the array of coefficients
//        int index = 0;
//        for (int i = 0; i < lenDim2; i++) {
//            for (int j = 0; j < lenDim2; j++) {
//                for (int k = 0; k < lenDim3; k++) {
//                    if ((i< lenDim1/2) && (j < lenDim2/2) && (k < lenDim3/2)) {
//                    } else {
//                        array[index++] =
//                                     new LocValPair(i,j,k,doubleArray[i][j][k]);
//                    }
//                }
//            }
//        }
//        // Now sort the array
//        Arrays.sort(array);
//
//    }
//



}
