/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Jon Frain
 */
import java.io.*;

public class Permutation {
    
   /****************************
    * permute
    * 
    * @param head - front of string
    * @param tail - end of string
    */ 
   public static void permute(String head, String tail) {
       
      // base case when tail is one character 
      if (tail.length() <= 1)
         System.out.println(head+tail);
      else {
         for (int i = 0; i < tail.length(); i++) {
            try {
               String newString = tail.substring(0, i) 
                                  + tail.substring(i + 1);

               permute(head + tail.charAt(i), newString);
            } catch (StringIndexOutOfBoundsException exception) {
               exception.printStackTrace();
            }
         }
      }
   }

   /****************************
    * main
    * 
    * 
    */ 
   public static void main(String args[]) throws IOException{
       String str = "01234567";
       permute("", str);
   }
}   
    
