/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Jon
 */

import java.io.*;
import java.util.*;

 // temporary class for testing
class lvlRegionSSE implements Comparable {
    public int lvl;
    int region;
    String regionLabel;
    double SSE;

    // ctor
    lvlRegionSSE(int reg, int level)
    {
       region = reg;
       lvl = level;
       regionLabel = Region.region.getRegionString(region) + lvl;
    }

    public int compareTo(Object arg1) {

        if(!(arg1 instanceof lvlRegionSSE))
           throw new ClassCastException();

       double sse2 = ( (lvlRegionSSE) arg1).getSSE();

       if( this.SSE > sse2 )
          return 1;
       else if( this.SSE < sse2 )
          return -1;
       else
          return 0;
    }

    void setSSE(double sse){
       SSE = sse;
    }

    double getSSE(){
       return SSE;
    }

    boolean isEqual(int level, int zVal){
       if ((region == zVal) && (level == lvl))
          return true;
       else
          return false;
    }

    // getLabel()
    //   - returns string describing where this region is
    //
   String getLabel(){
       return regionLabel;
   }

   public String toString(){
      return "region = " + regionLabel + "   SSE = " + SSE;
   }

   // unimplemented default constructor
   private lvlRegionSSE(){}
}